<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Class representing form wizard (a sequence of form_process pages).
 *	
 *	@author		Jan Hnatek
 */

class form_wizard {
//---------------//

	// VARIABLES
	//
	/** Name of this wizard */
	var $name;
	/**	Current wizard state */
	var $current;
	/** Name of the session variable (used with 'next' command) */
	var $session_var;
	/** State data .. structure:
		array ( array ( "class" => "classname", "url" => "http://...." ),
				array ( "class" => "classname", "url" => "http://...." ),
			);
	 */
	var $states = array ();

	// CONSTRUCTOR
	//
	/**	Create the wizard sequence based on given state data, instatiate proper class if present.
	 *	@param	$in_states	
	 *
	 */
	function form_wizard ($name, $in_states, $session_var) {
		global ${$session_var};
		$this->name = $name;
		if (is_array ($in_states))
			$this->states = $in_states;
		else
			return false;
		$this->session_var = $session_var;
		if (!isset (${$this->session_var})) {
			${$this->session_var} = 0;
			session_register ($this->session_var);
		}
		// check current state
		$this->current = ${$this->session_var};
		$this->check_current ();
		$this->instantiate ();
	}

	// METHODS
	//
	/**	Check correctness of current state.
	 *	Possible values : numeric {0 .. count($states)}.
	 *	@access	private
	 *	@return void
	 */
	function check_current () {
		global ${$this->session_var};
		// FIXME: ? loop by default ?
		if (!is_numeric ($this->current) || $this->current >= count ($this->states)) {
			$this->current = 0;
			${$this->session_var} = 0;
		}
	}
	
	/** Create an instance of current form.
	 *	The forms are suggested to not display themselves after saving data. (use next ())
	 *	@return void
	 *	@access private
	 *	see next()
	 */
	function instantiate () {
		// instantiate the form_process(_sequence) class
		$classname = $this->states[$this->current]['class'];
		debug ("form_wizard state: ".$this->current." / $classname");
		if (class_exists ($classname))
			eval ("new \$classname (\$classname, \$this);");
		else
			failexit ("class $classname not found ...");
	}
	
	/** Advance in wizard and instantiate the next form.
	 *	@return void
	 *	@access private
	 */
	function advance () {
		global ${$this->session_var};
		$old = $this->current++;
		$this->check_current ();
		debug ('<span style="color:red">ADVANCING to </span>'.$this->current);
		${$this->session_var} = $this->current;
		// prevent loop when we have (accidentally) only one item
		if ($old != $this->current)
			$this->instantiate ();
	}

} // class form_wizard

?>