<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Article edit module for ArtSys.<br>
 *	
 *	intermediate data structures:<br>
 *	associative array $art { "id", "title", "content", ... } with corresponding values<br>
 *	associative array $art_add { "author", "mode", "next_state" } with corresponding values<br>
 *	see art_edit.php<br>
 *	
 *	@author	Jan Hnatek
 */

class mform_article_edit extends form_process {
//-------------------------------------------//

    function custom_check () {
		global $user;
		//debug ("custom check");
		if (!$this->Values['Title'])
			$this->error ('Title', msg("no article title"));
		if (!$this->Values['Content'])
			$this->error ('Content', msg("no article content"));
		// handle second save when finished
		if (($this->Values['Finished'] == "on") && ($this->Values['SureFinished'] == '0'))
			if ($this->Values['Mode'] == "author") {
				// *** check a_correct in author mode
				if (!$user->check_my ("a_correct")) {
						$this->error ('Finished', msg("unable to edit1")."<br>".msg("unable to edit2"));
						$this->Values['SureFinished'] = '1';
				}
			} elseif ($this->Values['Mode'] == "editor") {
				// *** check a_approve in author mode
				if (!$user->check_my ("a_approve")) {
						$this->error ('Finished', msg("unable to edit1")."<br>".msg("unable to edit2"));
						$this->Values['SureFinished'] = '1';
				}
			}
	}
	
	/* NOTES on update article
			"author" mode .. 
				if finished	.. update { title, content, signature, author_done, finished_on } & redirect to 'list'
				else		.. update { title, content, signature } & edit again
			"editor" mode ..
				if finished	.. update { title, content, editor_done } & redirect to 'list'
				else		.. update { title, content } & edit again
				+FIXME: +finished_on ???? budem to menit po korekture ???
				nerozlisujem author_finished a editor_finished
	*/
	function store_data () {
		global $user, $db;
		//debug ("storing data");
		$date = datetime ();
		if ($this->Values["Id"] == "") {
			// *** 'new'
			// common part of query
			$q = "INSERT INTO Articles SET
				title='".$this->Values["Title"]."',
				menu_title='".$this->Values["MenuTitle"]."',
				subtitle='".$this->Values["Subtitle"]."',
				content='".$this->Values["Content"]."',
				keywords='".$this->Values["Keywords"]."',
				author='".$user->id."',
				signature='".$this->Values["Signature"]."',	created_on='$date'";
			if (is_numeric ($this->Values['Group']))
				$q .= ", igroup='".$this->Values['Group']."'";
			// insert the new article into DB
			if ($this->Values["Finished"] == "on")
				$db->exec ($q . ", finished_on='$date', author_done='1'", 1);
			else
				$db->exec ($q, 1);
			info ($db->report (msg("insert fail"), ""));

			$id = $db->last_insert_id ();
			// insert it in a group if some given
			if (is_numeric ($this->Values['Group'])) {
				$db->exec ("INSERT INTO Ainsertion SET
				article='$id', agroup='".$this->Values['Group']."'", 1);
				info ($db->report ("group ".msg("insert fail")));
			}
			// if finished was set, run away, else move to edit
			if ($this->Values["Finished"] == "on")
				print alert_run (msg("saved"));
			else
				print "<SCRIPT>document.location.href='main.php?sub=edit&id=$id'</SCRIPT>\n";
		} else {
			// *** 'edit'
			// common part of query
			$q = "UPDATE Articles SET
				title='".$this->Values["Title"]."',
				menu_title='".$this->Values["MenuTitle"]."',
				subtitle='".$this->Values["Subtitle"]."',
				content='".$this->Values["Content"]."',
				keywords='".$this->Values["Keywords"]."'";
			if (is_numeric ($this->Values['Group']))
				$q .= ", igroup='".$this->Values['Group']."'";
			// update the article in DB according to edit mode and state of article
			if ($this->Values["Mode"] == "author") {
				// *** AUTHOR mode
				if ($this->Values["Finished"] == "on") {
					$db->exec ($q . ",
						signature='".$this->Values["Signature"]."',
						finished_on='$date', author_done='1' WHERE id='".$this->Values["Id"]."'"); // , 1);
					info ($db->report (msg("update fail"), alert_run (msg("saved"))));
				} else {
					$db->exec ($q . ",
						signature='".$this->Values["Signature"]."'
						WHERE id='".$this->Values["Id"]."'"); // , 1);
					$this->Values["Nextstate"] = "correction";
				}
			} elseif ($this->Values["Mode"] == "editor") {
				// *** EDITOR mode
				if ($this->Values["Finished"] == "on") {
					$db->exec ($q . ", editor_done='1' WHERE id='".$this->Values["Id"]."'"); // , 1);
					info ($db->report (msg("update fail"), alert_run (msg("saved"))));
				} else {
					$db->exec ($q . "WHERE id='".$this->Values["Id"]."'"); // , 1);
					$this->Values["Nextstate"] = "approval";
				}
			} else
				print alert_run (msg("internal edit"));
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		} // 'edit' update
	} // store_data

    function display_form () {
		global $art, $art_add, $user, $agroups, $db;
		//debug ($art["id"]);
		//debug ($art["title"]);
		new form_hidden ($this, 'Id', $art["id"]);
		new form_hidden ($this, 'Mode', $art_add["mode"]);
		new form_hidden ($this, 'Nextstate', $art_add["next_state"]);
?>
<input type="hidden" name="id" value="<?= $art["id"]?>">
<table>
	<tr><td>Author:</td>
		<td><?= $art_add["author"]?></td>
	</tr>
	<tr><td>Title:</td>
		<td><?	new form_text ($this, 'Title', $art["title"], 'size="80"');
				$this->error_report ('Title');?></td>
	</tr>
	<tr><td>Menu title:</td>
		<td><?  // TODO: restrict this only to publishers++ ???
				new form_text ($this, 'MenuTitle', $art["menu_title"], 'size="70"');
				$this->error_report ('MenuTitle');
				echo "&nbsp;";
				help (msg ("menu title"));?></td>
	</tr>
	<tr><td>Subtitle:</td>
		<td><?	$subtitle =& new form_textarea ($this, 'Subtitle', $art["subtitle"], 'cols="70" rows="4"');
				// place Richedit editor with link
				// FIXME: img source ?
				// TODO: $gui->get_img () ?
				$editor =& new richedit ("items",
					"<img src=\"./gui/img/richedit.gif\" alt=\"Richedit editor\" border=0>");
				$editor->place ($subtitle->InputName, 'wsubtitle');
				//$editor->error_report ();
				if (isset ($editor->error)) {
					echo "&nbsp;";
					help (msg ("richtext unavailable"));
     			}
				$this->error_report ('Subtitle');
				?></td>
	</tr>
	<tr><td>Content:</td>
		<td><?	$content =& new form_textarea ($this, 'Content', $art["content"], 'cols="70" rows="15"');
				// place another link to Richedit editor
				$editor->place ($content->InputName, 'wcontent');
				//$editor->error_report ();
				if (isset ($editor->error)) {
					echo "&nbsp;";
					help (msg ("richtext unavailable"));
     			}
				$this->error_report ('Content');
				?></td>
	</tr>
	<tr><td>Keywords:</td>
		<td><?	new form_text ($this, 'Keywords', $art["keywords"], 'size="80"');
				$this->error_report ('Keywords');
				echo "&nbsp;";
				help (msg ("comma separator")); ?></td>
	</tr>
	<tr><td>Signature:</td>
		<td><?	// RINVIT: edit signature : author mode only or with a_approve rights
				if (($art_add["mode"] == "author") || ($user->check_my ("a_approve"))) {
					new form_textarea ($this, 'Signature', $art["signature"], 'cols="50" rows="4"');
					$this->error_report ('Signature');
					echo "&nbsp;";
					help (msg("article signature"));
				} else
					echo $art["signature"]; ?></td>
	</tr>
<?	// give initial group selector only since the first select (igroup selected only once)
	if (($this->Values["Group"] == "") && ($art["igroup"] == "")) : ?>
	<tr><td>Group:</td>
		<td><?	/* PREVIOUS :
				$RS = db_ exec ("SELECT id, name FROM Agroups ORDER BY id");
				info (db_ report ($RS, msg ("select fail")));
				$options = array ("" => msg ("pick group"));
				while ($row = get_result ($RS))
					$options[$row[0]] = $row[1];
				ALTERNATE : */
				$options[""] = msg("pick group");
				$options = $agroups->get_assoc ("id", "name", $options, "ORDER by id");
				info ($db->report ($agroups->get_error ()));
				new form_select ($this, 'Group', $options, "");
				$this->error_report ('Group');
				echo "&nbsp;";
				help (msg("initial group")); ?></td>
	</tr>
<?	endif ?>
</table>
<?	// give finalize checkbox only if not approved
	if ($art["approved"] != "1") : ?>
<table>
	<tr>
		<td><? 	echo msg("ready for")." ";
				new form_string ($this, 'Nextstate', $art_add["next_state"]); ?></td>
		<td width="220"><?
				new form_checkbox ($this, 'Finished', '');
				echo "&nbsp;";
				help (msg ("finalize article")); ?></td>
		<td></td>
	</tr>
	<tr><td colspan="3"><?
				$this->error_report ('Finished');
				new form_hidden ($this, 'SureFinished', '0');?>
</table>
<?	endif ?>
</form>
<?	}

} // class module_article_edit

$form =& new mform_article_edit ('article_edit');

?>
