<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Article grouping module for ArtSys.<br>
 *	
 *	intermediate data structure:<br>
 *	array of associative arrays $garticles { ("id", "author", "title", "issue"), (), ... } with corresponding values
 *	
 *	@author	Jan Hnatek
 */

class mform_article_groups extends form_process {
//---------------------------------------------//

    function custom_check () {
		if ($this->Values['Action'] == "")
			$this->error ('Action', msg("no action selected"));
		if ($this->Values['Action'] != "LIST")
			if ($this->Values['Group'] == "")
				$this->error ('Group', msg("no group selected"));
		if (!$this->Values['Anum'])
			$this->error ('Anum', msg("no art left"));
	}
	
	function store_data () {
		global $db, $articles;
		$this->display_form ();
		// *** INSERT
		if ($this->Values['Action'] == 'INS') {
			info ("Results:");info ("--------");
			for ($i=0; $i < $this->Values['Anum']; $i++)
				if (is_numeric ($this->Values["Article$i"])) {
					$aid = $this->Values["Article$i"];
					$gid = $this->Values["Group"];
					if ($articles->get_me_in_group ($aid, $gid)) {
						info (q ($this->Values["Atitle$i"]));
						info ("&nbsp;&nbsp;".msg("article is in group"));
					} else {
						$db->exec ("INSERT INTO Ainsertion SET article='$aid', agroup='$gid'", 1);
						info ($db->report (msg ("insert fail"), q($this->Values["Atitle$i"]) .' '. msg("saved")));
					}
			}
		// *** DELETE
		// TODO: after removing from A.igroup group should that be set to NULL ??
		} elseif ($this->Values['Action'] == 'DEL') {
			info ("Results:");info ("--------");
			for ($i=0; $i < $this->Values['Anum']; $i++)
				if (is_numeric ($this->Values["Article$i"])) {
					$aid = $this->Values["Article$i"];
					$gid = $this->Values["Group"];
					if ($articles->get_me_in_group ($aid, $gid)) {
						$db->exec ("DELETE FROM Ainsertion WHERE article='$aid' AND agroup='$gid'", 1);
						info ($db->report (msg ("delete fail"), q($this->Values["Atitle$i"]) .' '. msg("removed")));
					} else {
						info (q ($this->Values["Atitle$i"]));
						info ("&nbsp;&nbsp;".msg("article not in group"));
					}
			}
		// *** LIST
		} elseif ($this->Values['Action'] == 'LIST') {
			info ("Results:");info ("--------");
			for ($i=0; $i < $this->Values['Anum']; $i++) {
				info ("&nbsp;");
				$aid = $this->Values["Article$i"];
				if (is_numeric ($aid)) {
					$mygroups = $articles->get_my_groups ($aid);
					info ($db->report ($articles->get_error()));
					info (q ($this->Values["Atitle$i"]));
					foreach ($mygroups as $mygroup)
						info ("&nbsp;&nbsp;'".$mygroup['name']."'");
				}
			}
		} else
			info ("internal error, non-existing action");
	}
	
    function display_form () {
		global $garticles, $db, $agroups;
		$anum = count ($garticles);
		//debug ("total: ".$anum);
		//debug ($garticles[0]['id']);
		//debug ($garticles[0]['title']);
		
		// redundant check (the first is in art_groups.php)
		new form_hidden ($this, "Anum", $anum);
		$this->error_report ('Anum');
		// deploy article ids
		for ($i=0; $i < $anum; $i++) {
			new form_hidden ($this, "Article$i", $garticles[$i]['id']);
			// FIXME: makes mess in rendering when the whole article title is in quotes ...
			new form_hidden ($this, "Atitle$i", $garticles[$i]['title']);
		}
?>
<input type="hidden" name="list" value="<?= $GLOBALS['list'];?>">
<table>
	<tr><td>Perform action:</td>
		<td><?	// create action select box
				$options = array (
					"" => msg ("pick action"),
					"INS" => msg ("insert into"),
					"DEL" => msg ("remove from"),
					"LIST" => msg ("get groups")
				);
				new form_select ($this, 'Action', $options, ""); 
				$this->error_report ('Action');
			?></td>
	</tr>
	<tr><td>Group:</td>
		<td><?	// article group select box
				$groupsel[""] = msg("pick group");
				$groupsel = $agroups->get_assoc ("id", "name", $groupsel);
				info ($db->report ($agroups->get_error (), ""));
				new form_select ($this, 'Group', $groupsel, ""); 
				$this->error_report ('Group');
			?></td>
	</tr>
</table>
</form>
<?	}

} // class module_article_groups

$form =& new mform_article_groups ('article_groups');

?>
