<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Groups edit module for ArtSys.<br>
 *	
 *	intermediate data structure:<br>
 *	associative array $agroup { "id", "name", "menu_text", "description" } with corresponding values
 *	
 *	@author	Jan Hnatek
 */

class mform_group_edit extends form_process {
//-----------------------------------------//

    function custom_check () {
		debug ("custom check");
		if (!$this->Values['Name'])
			$this->error ('Name', msg("no name", "group"));
	}
	
	function store_data () {
		global $db;
		debug ("storing data");

		// retranslate checkbox data to db format
		$exported = ($this->Values["Exported"] == "on") ? '1' : '0';
		if ($this->Values["Id"] == "") {
			// *** 'new'
			// insert the new article group into DB
			$RS = $db->exec ("INSERT INTO Agroups SET
				name='".$this->Values["Name"]."',
				menu_text='".$this->Values["Menu_text"]."',
				exported='$exported',
				description='".$this->Values["Description"]."'", 1);
			info ($db->report (msg("insert fail")));
			if ($RS) {
				// get 'id' and move to edit
				$id = $db->last_insert_id ();
				print "<SCRIPT>document.location.href='main.php?sub=edit&id=$id'</SCRIPT>\n";
			} else {
				// failed: if it's because of duplicate name:
				if ($db->errno() == "1062") {
					$this->error ('Name', msg("duplicate value"));
					$this->display_form ();
				}
			}
		} else {
			// *** 'edit'
			// update the article in DB
			$db->exec ("UPDATE Agroups SET
				name='".$this->Values["Name"]."',
				menu_text='".$this->Values["Menu_text"]."',
				description='".$this->Values["Description"]."',
				exported='$exported'
				WHERE id='".$this->Values["Id"]."'", 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		}
	}

    function display_form () {
		global $agroup;
		//debug ($agroup["id"]);
		//debug ($agroup["name"]);
		//debug ($agroup["menu_text"]);
		//debug ($agroup["description"]);
		//debug ($agroup["exported"]);
		// duplicate, on purpose, don't delete
		new form_hidden ($this, 'Id', $agroup["id"]);
?>
<input type="hidden" name="id" value="<?echo $agroup["id"]?>">
<table>
	<tr>
		<td>Name:</td>
		<td><?	new form_text ($this, 'Name', $agroup["name"], 'size="80"');
				$this->error_report ('Name');?></td>
	</tr>
	<tr>
		<td>Issue menu text:</td>
		<td><?	new form_text ($this, 'Menu_text', $agroup["menu_text"], 'size="80"');?></td>
	</tr>
	<tr>
		<td>Description:</td>
		<td><?	new form_text ($this, 'Description', $agroup["description"], 'size="80"');?></td>
	</tr>
	<tr><td>Exported:</td>
		<td><?	// convert DB checkbox value to HTML's
				$agroup["exported"] = ($agroup["exported"] == '1') ? "on" : "";
				new form_checkbox ($this, 'Exported', $agroup["exported"]);
				echo "&nbsp;";
				help (msg ("exported group")); ?></td>
	</tr>
</table>
</form>
<?	}

} // class module_group_edit

$form =& new mform_group_edit ('group_edit');

?>
