<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

define ('ART_TITLE_MAX_LEN', 75);

/**	
 *	Issue edit modules for ArtSys. 1: Edit issue name and select articles.<br>
 *	
 *	intermediate data structure:<br>
 *	associative array $issue { "id", "name", ... } with corresponding values
 *	
 *	@author	Jan Hnatek
 */

class mform_issue_edit_1 extends form_process {
//-------------------------------------------//

    function custom_check () {
		debug ("custom check: 1");
		// handle add/del : +fake an error, so we don't advance in the wizard
		if ($this->Values['Add'] == msg('add')) {
			$this->error ('Add', 'fake');
			$this->Values['Anum']++;
		}
		if ($this->Values['Del'] == msg('del')) {
			$this->error ('Del', 'fake');
			$this->Values['Anum']--;
		}
		// check input
		if (!$this->Values['Name'])
			$this->error ('Name', msg("no name", "issue"));
	}
	
	function store_data () {
		global $db;
		debug ("storing data: 1");
		// if it's the right submit .. (these here only modify the form)
		if (($this->Values['Add'] != msg('add')) && ($this->Values['Del'] != msg('del'))) {
			if ($this->Values["Id"] == "") {
				// *** 'new'
				// insert the new issue into DB
				$RS = $db->exec ("INSERT INTO Issues SET
					name='".$this->Values['Name']."',
					subtitle='".$this->Values['Subtitle']."'", 1);
				info ($db->report (msg("insert fail"), msg("saved")));
				if ($RS) {
					$id = $db->last_insert_id ();
					// update issue info in every article in the new issue
					for ($i=0; $i < $this->Values['Anum']; $i++) {
						debug ("A $i id: ". $this->Values["Article$i"]);
						// TODO: ? test article approved ? 
						// or ignore it for a while (can be selected through query in selectbox $articles->get_new ())
						if (is_numeric ($this->Values["Article$i"])) {
							$db->exec ("UPDATE Articles SET 
								issue='$id', issue_name='".$this->Values['Name']."',
								iorder='$i' WHERE id='".$this->Values["Article$i"]."'", 1);
							info ($db->report (msg("update fail")));
						} // if is_numeric (article id)
					} // for all $anum
					// move to edit with $id
					print "<SCRIPT>document.location.href='main.php?sub=edit&id=$id'</SCRIPT>\n";
				} // if ($RS) of Issue INSERT
			} else {
				// *** 'edit'
				// update the issue in DB
				$db->exec ("UPDATE Issues SET name='".$this->Values['Name']."',
					subtitle='".$this->Values['Subtitle']."' WHERE id='".$this->Values['Id']."'", 1);
				info ($db->report (msg("update fail"), msg("saved")));
				// clear Articles.issue values (the old one)
				$db->exec ("UPDATE Articles SET issue=NULL, issue_name='' WHERE issue='".$this->Values['Id']."'", 1);
				info ($db->report (msg ("update fail")));
				// update issue info in every article in the new issue
				for ($i=0; $i < $this->Values['Anum']; $i++) {
					if (is_numeric ($this->Values["Article$i"])) {
						// TODO: ? test article approved ?
						$db->exec ("UPDATE Articles SET
							issue='".$this->Values['Id']."',
							issue_name='".$this->Values['Name']."',
							iorder='$i'
							WHERE id='".$this->Values["Article$i"]."'", 1);
						info ($db->report (msg ("update fail"))); // , msg("saved")  .. for every article
					} // is_numeric
				} // for each $anum
			} // *** 'new' / 'edit'
		}
	} // store_data ()
	
    function display_form () {
		global $issue, $articles;
		//debug ($issue["id"]);
		//debug ($issue["name"]);
		// duplicate on purpose, don't delete
		new form_hidden ($this, 'Id', $issue["id"]);
?>
<input type="hidden" name="id" value="<?echo $issue["id"]?>">
<table>	
	<tr><td>Name:</td>
		<td colspan="2"><?
		new form_text ($this, 'Name', $issue["name"], 'size="80"');
		$this->error_report ('Name');?></td>
	</tr>
	<tr><td>Subtitle:</td>
		<td colspan="2"><?
		new form_text ($this, 'Subtitle', $issue["subtitle"], 'size="80"');
		$this->error_report ('Subtitle');?></td>
	</tr>
	<tr><td>Articles:</td>
		<td><?
		new form_submit ($this, 'Add', msg('add'), 'title="'.msg ("more articles").'"');
		echo "&nbsp;";
		new form_submit ($this, 'Del', msg('del'), 'title="'.msg ("less articles").'"');
		echo "&nbsp;";
		help (msg ("menu order"));
		?></td></tr>
<?		// prepare articles select box .. to $options array
		$options[' '] = msg ('pick article');
		$selected = array ();
		$menu_titles = array ();
		// get issue articles into an array, but only when this is 'edit'
		if ($issue['id'] != "") {
			$arts = $articles->get_issue ($issue['id']);
			// FIXME: depends on implementation in mysql_db -> ???? should be ok now
			//info ($db->report ($articles->get_error ()));
			foreach ($arts as $art) {
				$options[$art['id']] = string_cut ($art['title'], ART_TITLE_MAX_LEN);
				array_push ($selected, $art['id']);
				$menu_titles[$art['id']] = $art['item'];
			}
			// add separator
			$options['  '] = "------------------";
			$new = 1;
		} else
			// add 3 new article select boxes
			$new = 3;
		// add new articles
		$arts = $articles->get_new ();
		info ($GLOBALS['db']->report ($articles->get_error ()));
		foreach ($arts as $art) {
			$options[$art['id']] = string_cut ($art['title'], ART_TITLE_MAX_LEN);
			$menu_titles[$art['id']] = $art['item'];
		}
		
		// TODO: as attribute in Issues ???   not necessarily
		$anum = (isset ($this->Values['Anum'])) ? $this->Values['Anum'] : count ($selected) + $new;
		new form_hidden ($this, 'Anum', $anum);
		for ($i=0; $i < $anum; $i++) {
			echo "<tr><td align=\"right\">".($i+1).":</td><td>";
			new form_select ($this, 'Article'.$i, $options, $selected[$i]);
		}
?>
</table>&nbsp;
</form>
<?	}

} // class module_issue_edit_1

?>
