<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	User edit module for ArtSys.<br>
 *	
 *	intermediate data structure:<br>
 *	associative array $auser { "id", "name", ... } with corresponding values
 *	
 *	@author	Jan Hnatek
 */

class mform_user_edit extends form_process {
//----------------------------------------//

    function custom_check () {
		global $user;
		debug ("custom check");
		if (!$this->Values ['Name'])
			$this->error ('Name', msg("no name", "user"));
		// check this : only in admin mode
		if ($user->check_my ("users"))
			if (!$this->Values ['Username'])
				$this->error ('Username', msg("no username"));
	}
	
	function store_data () {
		global $user, $db, $DEFAULT_PASSWORD;
		debug ("storing data");
		// ** NORMAL user edit mode
		if ($user->check_my ("users") == false) {
			$db->exec ("UPDATE Users SET 
				name='".$this->Values["Name"]."', 
				email='".$this->Values["Email"]."', 
				signature='".$this->Values["Signature"]."'
				WHERE id='".$this->Values["Id"]."'", 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
			return;
		}
		// ** ADMIN user edit mode
		// retranslate checkbox data to db format
		$blocked = ($this->Values["Blocked"] == "on") ? '1' : '0';
		if ($this->Values["Id"] == "") {
			// this means we came from "new"
			// insert into DB
			$RS = $db->exec ("INSERT INTO Users SET 
				name='".$this->Values["Name"]."', 
				username='".$this->Values["Username"]."',
				email='".$this->Values["Email"]."',
				signature='".$this->Values["Signature"]."',
				password='$DEFAULT_PASSWORD', blocked='$blocked',
				ugroup='".$this->Values["Group"]."'", 1);
			info ($db->report (msg("insert fail"), msg("saved")));
			if ($RS) {
				// get 'id' and move to edit
				$id = $db->last_insert_id ();
				print "<SCRIPT>document.location.href='main.php?sub=edit&id=$id'</SCRIPT>\n";
			} else {
				// failed: if it's because of duplicate name:
				if ($db->errno() == "1062") {
					$this->error ('Name', msg("duplicate value"));
					$this->display_form ();
				}
			}
		} else {
			// this means just normal save in "edit"
			// update user in DB, don't change pass !
			$q = "UPDATE Users SET 
				name='".$this->Values["Name"]."', 
				username='".$this->Values["Username"]."',
				email='".$this->Values["Email"]."',
				signature='".$this->Values["Signature"]."',
				blocked='$blocked', ugroup='".$this->Values["Group"]."'
				WHERE id='".$this->Values["Id"]."'";
			$db->exec ($q, 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		}
	}
	
    function display_form () {
		global $auser, $db;
		// ** switch NORMAL/ADMIN user edit mode
		$admin = $GLOBALS['user']->check_my ("users");
		//debug ($auser["id"]);
		//debug ($auser["name"]);
		//debug ($auser["blocked"]);
		// TODO: info about what am I editing
		new form_hidden ($this, 'Id', $auser["id"]);
?>
<input type="hidden" name="id" value="<?echo $auser["id"]?>">
<table>	
	<tr><td>Real name:</td>
		<td><?	new form_text ($this, 'Name', $auser["name"], 'size="80"');
				$this->error_report ('Name');?></td>
	</tr>
<?	if ($admin) : ?>
	<tr><td>Username:</td>
		<td><?	new form_text ($this, 'Username', $auser["username"], 'size="80"');
				$this->error_report ('Username');?></td>
	</tr>
<?	endif ?>
	<tr><td>Email:</td>
		<td><?	new form_text ($this, 'Email', $auser["email"], 'size="80"');
				$this->error_report ('Email');?></td>
	</tr>
	<tr><td>Signature:</td>
		<td><?	//new form_text ($this, 'Signature', $auser["signature"], 'size="80"');
				new form_textarea ($this, 'Signature', $auser["signature"], 'cols="50" rows="4"');
				$this->error_report ('Signature');?></td>
	</tr>
<?	if ($admin) : ?>
	<tr><td>Blocked:</td>
		<td><?	// convert DB checkbox value to HTML's
				$auser["blocked"] = ($auser["blocked"] == '1') ? "on" : "";
				new form_checkbox ($this, 'Blocked', $auser["blocked"]); 
				// TODO: ? make sure nobody blocks 'root' ? ?></td>
	</tr>
	<tr><td>Group:</td>
		<td><?	// create group select box
				// groups in same order as in db, should be: ASC with more rights
				// TODO: if (use db_entity ???) see article_edit with group selection
				// probably not by this one, Ugroups won't have an instance of db_entity
				$db->exec ("SELECT id, name FROM Ugroups ORDER BY id");
				info ($db->report (msg ("select fail")));
				$options = array ();
				while ($row = $db->get_result ())
					$options[$row[0]] = $row[1];
				new form_select ($this, 'Group', $options, $auser["ugroup"]); 
				$this->error_report ('Group');?></td>
	</tr>
<?	endif ?>
</table>
</form>
<?	}

} // class module_user_edit

$form =& new mform_user_edit ('user_edit');

?>
