<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Users' password edit module for ArtSys.<br>
 *	
 *	intermediate data structure:<br>
 *	associative array $userpass { "id" } with corresponding values
 *	
 *	@author	Jan Hnatek
 */

class mform_user_pass extends form_process {
//----------------------------------------//

    function custom_check () {
		global $user;
		//debug ("custom check");
		if (!$this->Values ['Password'])
			$this->error ('Password', msg("no pass"));
		if (!$this->Values ['Retry'])
			$this->error ('Retry', msg("no retry"));
		elseif ($this->Values ['Retry'] != $this->Values ['Password'])
			$this->error ('Retry', msg("no match"));
		// check this : only in normal user mode or if changing myself
		if (($user->check_my ("users") == false) || ($user->id == $this->Values['Id']))
			if (!$this->Values ['Oldpass'])
				$this->error ('Oldpass', msg('no old'));
		// TODO: password length check ?
	}
	
	function store_data () {
		global $user, $db;
		debug ("storing data");
		
		// ** NORMAL user setpass mode : check the old pass, existence in db ...
		if (($user->check_my ("users") == false) || ($user->id == $this->Values['Id'])) {
			$RS = $db->exec ("SELECT password, name FROM Users WHERE id='".$this->Values["Id"]."'", 1);
			if (!test ($RS, msg("update fail")))
				return;
			list ($db_passwd, $realname) = $db->get_result ();
			// FIXME: need to check this ???
			if ($user->realname != $realname) {
				info ("Your real name doesn't match the one in db !!!");
				return;
			}
			// check old password
			$oldpass = md5 ($this->Values["Oldpass"]);
			if ($oldpass != $db_passwd) {
				$this->error ('Oldpass', msg("bad oldpass"));
				$this->display_form ();
				return;
			}
		}
		// ** ADMIN user setpass mode : update user's (NOT admin's !) password in DB, without checking previous
		// encrypt password
		$passwd = md5 ($this->Values["Password"]);
		$db->exec ("UPDATE Users SET password='".$passwd."' WHERE id='".$this->Values["Id"]."'", 1);
		info ($db->report (msg("update fail"), msg("saved")));
		$this->display_form ();
	}
	
    function display_form () {
		global $userpass, $user;
		//debug ($userpass["id"]);
		// TODO: info about what am I editing : or in the inculde file (use_passwd) ?
		//$gui->heading ("Setting password for user: ".$userpass["name"]);
		// TODO: msg ()
		info ("Setting password for user '".$userpass["username"]."' :");
		info ("<br>");
		
		new form_hidden ($this, 'Id', $userpass["id"]);
?>
<input type="hidden" name="id" value="<?echo $userpass["id"]?>">
<table>	
<?		// ** switch NORMAL/ADMIN password change : 
		// give previous password if normal user or changing myself
		if (($user->check_my ("users") == false) || ($user->id == $userpass["id"])) : ?>
	<tr><td>Old password:</td>
		<td><?	new form_password ($this, 'Oldpass', '', 'size="50"');
				$this->error_report ('Oldpass');?></td>
	</tr>
<?		endif ?>
	<tr><td>Password:</td>
		<td><?	new form_password ($this, 'Password', '', 'size="50"');
				$this->error_report ('Password');?></td>
	</tr>
	<tr><td>Re-enter:</td>
		<td><?	new form_password ($this, 'Retry', '', 'size="50"');
				$this->error_report ('Retry');?></td>
	</tr>
</table>
</form>
<?	}

} // class module_user_pass

$form =& new mform_user_pass ('user_pass');

?>
