<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# modules : implementation admin part modules

	require_once "$INCLUDE_DIR/classes/class.module.php";
	require_once "$INCLUDE_DIR/classes/class.button.php";


/**
 *	Article management module for ArtSys.<br>
 *	Contains custom menu definition.
 *
 *	@author		Jan Hnatek
 */
class module_articles extends module {
//----------------------------------//

	function module_articles ($active = false) {
		global $section, $subsection, $BASE_ADMIN_URL;
		$this->name = "articles";
		$this->active = $active;
		
		$B_save =& new button_save ($section, msg("submit"));
		$B_exec =& new button_save ($section, msg("commit"));
		$B_reset =& new button_reset (msg("reset"));
		$B_delete =& new button_delete ($section, msg("delete"), msg('confirm delete', 'article(s)'));
		$B_done =& new button_done ($section);
		$B_img =& new menu_button ($section, "image", msg("image"), "image",
		"ib = window.open('$BASE_ADMIN_URL/images.php', 'winimage', 'width=650, height=450, resizable=yes, scrollbars=yes'); ib.focus();");
		// TODO: seems like 'view' and 'view' will not be the same,
		// meaning the ones in 'new'/'edit' will have to be popup
		// while the one now disabled in list can be a browser (with list as input)
		// perhaps the second one should be renamed to 'art_browse' or something to prevent confusion
		//$B_view =& new link_button ($section, "view", msg("view"), "view", "linkidto");
		$B_view =& new menu_button ($section, "view", msg("view"), "view",
		"av = window.open('$BASE_ADMIN_URL/art_view.php?id='+document.items.id.value, 'aview', 'width=650, height=450, resizable=yes, scrollbars=yes'); av.focus();");

		$this->menu = array (
			"list"	=> array ( "art_list.php",
				new button_new ($section, msg("new")),
				new button_edit ($section, msg("edit")),
				// 'linklistto' here (unlike the $B_view) !!
				//new link_button ($section, "view", msg("view"), "view", "linklistto"),
				new link_button ($section, "approve", msg("approve"), "approve", "linklistto"),
				new link_button ($section, "unapprove", msg("unapprove"), "unapprove", "linklistto"),
				new link_button ($section, "agroups", msg("agroups"), "agroups", "linklistto"),
				$B_delete,
			),
			"new"		=> array ("art_edit.php",	$B_save, $B_reset, $B_img, $B_view, $B_done),
			"edit"		=> array ("art_edit.php",	$B_save, $B_reset, $B_img, $B_view, $B_delete, $B_done),
			//"view"		=> array ("art_view.php",	$B_done),
			"approve" 	=> array ("art_approve.php", $B_done),
			"unapprove" => array ("art_unapprove.php", $B_done),
			"agroups"	=> array ("art_groups.php", $B_exec, $B_reset, $B_done),
			"delete"	=> array ("art_del.php", $B_done),
		);
		$this->open_form = array ("new", "edit", "agroups");
		$this->set_sub ();
	}
}


/**
 *	Group management module for ArtSys.<br>
 *	Contains custom menu definition.
 *	
 *	@author		Jan Hnatek
 */
class module_groups extends module {
//--------------------------------//

	function module_groups ($active = false) {
		global $section, $subsection;
		$this->name = "groups";
		$this->active = $active;
		
		$B_save =& new button_save ($section, msg("submit"));
		$B_reset =& new button_reset (msg("reset"));
		$B_delete =& new button_delete ($section, msg("delete"), msg('confirm delete', 'group(s)'));
		$B_done =& new button_done ($section, msg("done"));
		
		$this->menu = array (
			"list"	=> array ( "gro_list.php",
				new button_new ($section, msg("new")),
				new button_edit ($section, msg("edit")),
				$B_delete,
			),
			"new"	=> array ("gro_edit.php",	$B_save, $B_reset, $B_done),
			"edit"	=> array ("gro_edit.php",	$B_save, $B_reset, $B_delete, $B_done),
			"delete"=> array ("gro_del.php",	$B_done),
		);
		$this->open_form = array ("new", "edit");
		$this->set_sub ();
	}
}

/**
 *	Issue management module for ArtSys.<br>
 *	Contains custom menu definition.
 *	
 *	@author		Jan Hnatek
 */
class module_issues extends module {
//--------------------------------//

	function module_issues ($active = false) {
		global $section, $subsection, $BASE_ADMIN_URL;
		$this->name = "issues";
		$this->active = $active;
		
		$B_save =& new button_save ($section, msg("submit"));
		$B_reset =& new button_reset (msg("reset"));
		$B_delete =& new button_delete ($section, msg("delete"), msg('confirm delete', 'issue(s)'));
		$B_done =& new button_done ($section, msg("done"));
		
		// see issue_edit for details on wizard sequence / 'iestate' variable
		$B_next =& new button_next ($section, msg("next"));
		
		$this->menu = array (
			"list"	=> array ( "iss_list.php", 
				new button_new ($section, msg("new")),
				new button_edit ($section, msg("edit")),
				new link_button ($section, "test", msg("test"), "test", "linklistto"),
				new link_button ($section, "publish", msg("publish"), "publish", "linklistto"),
				new link_button ($section, "archive", msg("archive"), "archive", "linklistto"),
				new link_button ($section, "unarchive", msg("unarchive"), "unarchive", "linklistto"),
				$B_delete,
			),
			"new"		=> array ("iss_edit.php", $B_save, $B_next, $B_reset, $B_done),
			"edit"		=> array ("iss_edit.php", $B_next, $B_reset, $B_delete, $B_done),
			"test"	 	=> array ("iss_test.php", $B_done),
			"publish" 	=> array ("iss_publish.php", $B_done),
			"archive"	=> array ("iss_archive.php", $B_done),
			"unarchive"	=> array ("iss_unarchive.php", $B_done),
			"delete"	=> array ("iss_del.php", $B_done),
		);
		$this->open_form = array ("new", "edit");
		$this->set_sub ();
	}
}


/**
 *	ADMIN User management module for ArtSys.<br>
 *	Edit settings of all users in db.<br>
 *	
 *	@author		Jan Hnatek
 */
class module_users_admin extends module {
//-------------------------------------//

/*	TODO:
	! delete currently logged in user ?
	! change pass of currently logged in user
 */

	function module_users_admin ($active = false) {
		global $section, $subsection;
		$this->name = "users";
		$this->active = $active;
		
		$B_save =& new button_save ($section, msg("submit"));
		$B_reset =& new button_reset (msg("reset"));
		$B_delete =& new button_delete ($section, msg("delete"), msg('confirm delete', 'user(s)'));
		$B_done =& new button_done ($section, msg("done"));
		
		$this->menu = array (
			"list"	=> array (
				"use_list.php", 
				new button_new ($section, msg("new")),
				new button_edit ($section, msg("edit")),
				new link_button ($section, "passwd", msg("passwd"), "passwd", "linklistto"),
				$B_delete,
			),
			"new"	=> array ("use_edit.php",	$B_save, $B_reset, $B_done),
			"edit"	=> array ("use_edit.php",	$B_save, $B_reset, $B_delete, $B_done),
			"passwd"=> array ("use_passwd.php",	$B_save, $B_reset, $B_done),
			"delete"=> array ("use_delete.php",	$B_done),
		);
		$this->open_form = array ("new", "edit", "passwd");
		$this->set_sub ();
	}
}

/**
 *	NORMAL User management module for ArtSys.<br>
 *	Only edit "my own" preferences and changeable values (real name, mail, ...).<br>
 *
 *	@author		Jan Hnatek
 */
class module_users_normal extends module {
//--------------------------------------//

	function module_users_normal ($active = false) {
		global $section, $subsection, $id, $user;
		$this->name = "users";
		$this->active = $active;

		// don't use linklistto, since we don't have list
		$B_save =& new button_save ($section, msg("submit"), "linkto");
		$B_reset =& new button_reset (msg("reset"));
		$B_done =& new button_done ($section, msg("done"));
		$B_pass =& new link_button ($section, "passwd", msg("passwd"), "passwd", "linkidto");

		$this->menu = array (
			"edit"	=> array ("nuse_edit.php",		$B_save, $B_reset, $B_pass, $B_done),
			"passwd"=> array ("nuse_passwd.php",	$B_save, $B_reset, $B_done),
		);
		$this->open_form = array ("edit", "passwd");
		$this->set_sub ();
	}
}

/**
 *	Admin module for ArtSys.<br>
  *
 *	@author		Jan Hnatek
 */
class module_admin extends module {
//-------------------------------//

	function module_admin ($active = false) {
		global $section, $subsection, $id, $user, $BASE_ADMIN_URL;
		$this->name = "admin";
		$this->active = $active;

		// don't use linklistto, since we don't have list
		//$B_save =& new button_save ($section, msg("submit"), "linkto");
		//$B_reset =& new button_reset (msg("reset"));
		$B_done =& new button_done ($section, msg("done"));
		$B_img =& new menu_button ($section, "image", msg("image"), "image",
		"ib = window.open('$BASE_ADMIN_URL/images.php', 'winimage', 'width=700, height=450, resizable=yes, scrollbars=yes'); ib.focus();");

		$this->menu = array (
			"info"	=> array ("adm_info.php",	$B_done, $B_img),
			"log"	=> array ("include_template.php",	$B_done),
		);
		$this->open_form = array ("info", "passwd");
		$this->set_sub ();
	}
}

?>
