<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	An object to work with MySQL database.<br>
 *	Includes functions to connect, exec queries, return results, close...
 *	
 *	@author	Jan Hnatek
 */

class mysql_db {
//------------//

	// VARIABLES
	//
	var $name;
	var $host;
	var $user;
	var $password;
	var $display_debug;
	var $conn;
	var $persistent;
	// TODO: ?
	//var $dateformat;
	var $rs;

	// COSNTRUCTOR
	//
	/** A constructor for mysql_db class.
	 */
	function mysql_db ($iname, $ihost, $iuser, $ipasswd, $idebug=0) {
		$this->name = $iname;
		$this->host = $ihost;
		$this->user = $iuser;
		$this->password = $ipasswd;
		$this->display_debug = $idebug;
	}

	// METHODS
	//
	/**	Open a database connection.
	 *	@param $persist Say whether open a persistent database connection or not (1/0).
	 *	@access	public
	 *	@return	DB connection object
	 */
	function open ($persist=0) {
		$this->persistent = $persist;
		error ($this->user, "mysql_db->open: database user not specified");
		if ($this->persistent == 1) {
			$this->conn = mysql_pconnect ($this->host, $this->user, $this->password);
		} else
			$this->conn = mysql_connect ($this->host, $this->user, $this->password);
		error ($this->conn, "mysql_db->open: database connection failed");
		error (mysql_select_db ($this->name, $this->conn), "mysql_db->open: failed to select database");
		return $this->conn;
	}

	/**	Close database connection.
	 *	@access	public
	 */
	function close () {
		//mysql_free_result ($this->rs);
		mysql_close ();
	}
	
	/**	Execute a database query. Store and return its result.
	 *	Add *any* value as the second parameter to display debug information on this particular query.
	 *	@access	public
	 *	@return query result or false when query failed
	 */
	function exec ($query) {
		error ($query, "mysql_db->exec: no query given");
		// TODO: remove when done ... or comment out the if statement to get REAL mess :-)
		if (func_num_args() > 1)
			$this->debug ($query);
		$this->rs = mysql_query ($query, $this->conn);
		return $this->rs;
	}
	
	/**	Return number of rows in result
	 *	@access	public
	 */
	function num_rows () {
		// num_rows (-1 on error, 0 false too; non-zero OK)
		$x = ($this->rs) ? mysql_num_rows ($this->rs) : 0;
		if ($x == -1) {
			$this->debug ("mysql_db->num_rows: failed to get result (result == -1)");
			$x = 0;
		}
		return $x;
	}
	
	/**	Return information string depending on success of last query.
	 *	@param $msg_fail	Optional string to describe the error, if any. Comes with detailed information from mysql.
	 *	@param $msg_ok		Optional string to return, when query was succesfully done.
	 *	@access	private
	 */
	function report ($msg_fail="", $msg_ok="") {
		if (!$this->rs)
			return msg("db error")." (".$this->errno().") : ".$this->error()."<br>".$msg_fail."<br>";
		else
			return $msg_ok;
	}
	
	/**	Debug function. Writes to output, depending on the private value of <code>debug</code> variable.
	 *	@access	public
	 */
	function debug ($query) {
		if ($this->display_debug)
			echo "\n<code style=\"color:blue\">QUERY: $query</code><br>\n";
	}

	// WRAPPERS
	//
	/**	Wrapper, return result of <code>mysql_errno()</code>.
	 *	@access	public
	 */
	function errno () {
		return mysql_errno();
	}
	/**	Wrapper, return result of <code>mysql_error()</code>.
	 *	@access	public
	 */
	function error () {
		return mysql_error();
	}
	/**	Wrapper, return a result row as an enumerated array or FALSE.
	 *	@access	public
	 */
	function get_result () {
		return mysql_fetch_row ($this->rs);
	}
	
	/**	Wrapper, return a result row as an associative array, a numeric array, or both.
	 *	@access	public
	 */
	function get_result_array ($result_type = MYSQL_BOTH) {
		return mysql_fetch_array ($this->rs, $result_type);
	}
	
	/**	Wrapper, return a result row as an object.
	 *	@access	public
	 */
	function get_result_object () {
		return mysql_fetch_object ($this->rs);
	}
	
	/**	Wrapper, return number of affected rows in previous operation.
	 *	@access	public
	 */
	function get_affected_rows () {
		return mysql_affected_rows ();
	}
	
	/**	Wrapper, return the id generated from the previous INSERT operation.
	 *	@access	public
	 */
	function last_insert_id () {
		return mysql_insert_id ($this->conn);
	}

} // class db

?>