<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################

/**	
 *	Richedit editor control object.
 *	
 *	@author	Jan Hnatek
 */
class richedit {
//------------//

	// VARIABLES
	//
	var $browser;
	var $supported;
	var $form;
	var $default_text;
	var $error;

	// CONSTRUCTOR
	//
	/**	Richedit contructor.
	 *	Sets the form name and internal value <code>supported</code> based on current browser.
	 *	@param	$iform	Name of the form, whose items are we editing.
	 *	@param	$deftext	Default text of richedit links (useful, if it's an image).
	 *	@access	public
	 */
	function richedit ($iform, $deftext = "") {
		$this->form = $iform;
		$this->default_text = $deftext;
		$this->browser = getenv ("HTTP_USER_AGENT");
		//debug ("<br>".$this->browser);
		$this->supported = $this->check_browser ();
	}

	// METHODS
	//
	/** Recognize the browser, see if we can enable richtext editor.
	 *	Is called from constructor.
	 *	@access	private
	 *	@return	bool
	 */
	function check_browser () {
		if (preg_match ("/MSIE/i", $this->browser)) {
			if (preg_match ("/Mac/i", $this->browser))
				return false;
			// Opera 6.01 tested .. failed
			elseif (preg_match ("/Opera/i", $this->browser))
				return false;
			elseif (preg_match ("/Windows/i", $this->browser)) {
				$version = preg_replace ("/^.*MSIE ([0-9]\.[0-9]).*$/", "\\1", $this->browser);
				//debug ($version);
				return ($version >= 5.5) ? true : false;
    		}
		} elseif (preg_match("/Mozilla/i", $this->browser)) {
			if (preg_match ("/Mac/i", $this->browser))
				return false;
			elseif (preg_match ("/Windows/i", $this->browser))
				return false;
		}
		return false;
	}
	
	/**	Place the richedit control tag in the document.
	 *	Echoes result of <code>get</code> method.
	 *	@param	$item	Name of the form item which' contents should be edited.
	 *	@param	$text	Text of the link. Possibly may be an img tag.
	 *	@access	public
	 *	@return void
	 */
	function place ($item, $wname, $text="") {
		if ($this->supported) {
			if ($text == "")
				$text = $this->default_text;
			echo $this->get ($item, $wname, $text);
		} else
			$this->error = "Your browser is not supported";
	}
	
	/**	Returns the code of the richedit link (which opens new window).
	 *	@param	$item	Name of the form item which' contents should be edited.
	 *	@param	$wname	Javascript name of the window to create.
	 *	@param	$text	Text of the link. Possibly may be an img tag.
	 *	@access	public
	 *	@return string (anchor tag)
	 */
	function get ($item, $wname, $text="") {
		if ($this->supported) {
			if ($text == "")
				$text = $this->default_text;
			return "<a href=\"#\" onClick=\"rw = window.open('rte/popup_editor.php?form=". $this->form ."&item=$item&msg=".
			urlencode (msg("editor submit")). "', '$wname', 'width=650, height=450, resizable=yes'); rw.focus();\">$text</a>";
		} else
			return false;
	}
	
    /**	Prints formatted error message.
     *	Applications should call this function at a 'placeholder' that displays an error message if error occurs.
     *	@return void
     *	@access public
     */
	function error_report () {
		if (isset ($this->error)) {
			printf ("<br>%s", $this->error);
			return true;
		} else
			return false;
	}

} // class richedit

?>