<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# some very basic functions
# 

// simple debug
$DEBUG = 0;
function debug ($text) {
	global $DEBUG;
	if ($DEBUG)
		echo "\n<code style=\"color:green\">$text</code><br>\n";
}

// informative function
function info ($text) {
	if ($text != "")
		echo "<p class=\"info\">$text</p>\n";
}

// failure report and exit
function failexit ($text) {
	echo "\n<code style=\"color:red\">$text</code><br>\n";
	exit;
}

// script alert message
function alert ($msg) {
	return "<SCRIPT>alert('$msg');</SCRIPT>\n";
}

// single quote quoting function
function q ($text, $style="quotation") {
	return "<SPAN class=\"$style\">'".$text."'</SPAN>";
}

// TODO: ?
// picture for richedit, help, ...
//function img ($name, $file, 

// simple hint/help system
function help ($text) {
	global $img_counter;
	if (!isset ($img_counter))
		$counter = 0;
	$name = "img".$img_counter++;
	// FIXME: doesn't work in Netscape.
	// TODO: $gui->img ()
	?><img name="<?= $name?>" src="./gui/img/question.gif" alt="help" onclick="help_window('<?= $text?>')"
	onmouseover="hilite('<?= $name?>')" onmouseout="unhilite('<?= $name?>')" ><?
} // help
function help_script () { ?>
	<script language="JavaScript1.1" type="text/javascript">
	function help_window (message) {
		alert (message);
	}
	function hilite (iname) {
		document[iname].border = 1;
	}
	function unhilite (iname) {
		document[iname].border = 0;
	}
	</script>
<?} // help_script

// script alert message with run-away
// (default location is the "list" part of current module)
// FIXME: will we need this for different files (!= main.php) ? different modules (from the active one) ?
function alert_run ($msg, $dest = "list") {
	return "<SCRIPT>alert('$msg'); document.location.href='main.php?sub=$dest';</SCRIPT>\n";
}

// simple assertion function
function error ($value, $output, $file = "") {
	if (!$file) {
		if (!$value)
			failexit ("Assertion failed: <b>$output</b>, exiting ...<br>\n");
	} else
		if (!$value)
			failexit ("Assertion failed in $file:<br><b>$output</b>, exiting ...<br>\n");
}

// simple testing function
function test ($value, $output) {
	if (!$value) {
		print ("<b>$output</b><br>\n");
		return false;
	} else
		return true;
}

// return current date & time in DB format
function datetime () {
	# '2001-11-18 20:52:00'
	return date ("Y-m-d H:i:s");
}

?>
