<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# system messages and encoding
#

// charset specified in config.php
//$CHARSET = "iso-8859-1";

$MSG = array (

// general

	"login submit"		=> "Submit",
	"login reset"		=> "Reset",
	# be careful with ', it must be escaped !!! (when used in javasript)
	"no rights"			=> "You don\'t have rights for that",
	"noscript"			=> "Sorry, but you won't be able to log in. <br>Your browser doesn't support javascript.<br>",
	"public pages"		=> "public pages",
	"logout"			=> "logout",
	"close"				=> "close",

	// TODO: "internal" errors : move them to a separate array, won't be translated, shouldn't be visible
	"internal edit" 	=> "internal error, unknown edit type",

// login part

	"login screen"		=> "Article System login screen",
	"login username"	=> "Username:",
	"login passwd"		=> "Password:",
	"wrong login"		=> "Wrong Username or Password, please try again",

// db

	"db error"			=> "db error, db says",
	"saved"				=> "saved",
	"removed"			=> "removed",
	"select fail"		=> "select failed",
	"insert fail"		=> "insert failed",
	"update fail"		=> "update failed",
	"delete fail"		=> "delete failed",

// form buttons

	"submit"	=> "save",
	// used with 'performing actions', where's more options to run
	"commit"	=> "execute",
	"save"		=> "save",
	"next"		=> "next",
	"prev"		=> "prev",
	"reset"		=> "reset",
	"done"		=> "back",
	"delete"	=> "delete",
	"new"		=> "new",
	"edit"		=> "edit",
	"view"		=> "view",
	"test"		=> "test",
	"publish"	=> "publish",
	"archive"	=> "archive",
	"unarchive"	=> "unarchive",
	"add"		=> " + ",
	"del"		=> " - ",
	"approve"	=> "approve",
	"unapprove"	=> "unapprove",
	"agroups"	=> "groups",
	"passwd"	=> "change password",
	"upload"	=> "upload image",
	"upload send" => "Send",
	"image"		=> "insert image",
	"pick action" => "... pick an action",

// common for the parts down here
	"deleted"			=> "Deleted: ",
	"no item selected"	=> "No item selected, please select one.",
	//"This value must be unique in database, but you selected a value, which already exists.",
	"duplicate value"	=> "This value must be unique, but you selected a value, which already exists.
		<br>Please choose a different one.",
  	"feature not implemented"	=> "This feature is not implemented (yet, hopefully).",

// replaced items' names
	"article"	=> "article",
	"group"		=> "group",
	"issue"		=> "issue",
	"user"		=> "user",
	"article(s)"	=> "article(s)",
	"group(s)"		=> "group(s)",
	"issue(s)"		=> "issue(s)",
	"user(s)"		=> "user(s)",

// replaced items
	"not present"		=> "No such %ITEM% found in database.",
	"not selected"		=> "No %ITEM% selected, please select one.",
	"no name"			=> "The %ITEM% must have a name",
	"not deleted"		=> "Given %ITEM% was not deleted (is not present ?).",
	// this is displayed through javascript:
	"confirm delete"	=> "You are about to delete %ITEM% from database.\\nThis change is irreversible. Are you sure?",

// articles

	"noadd limits"			=> "Note: limits are not additive.",
	"no article title"		=> "Your article has no title",
	"no article content"	=> "Your article is empty",
	"edit approved article" => "This article is already approved, you shouldn't edit it",
	"edit finished article" => "This article is finished, you shouldn't edit it",
	"finalize article"		=> "Check this, if you are finished with this article.",
	"ready for"				=> "This article is ready for",
	"del article in issue"	=> "You can't delete an article, which is published (in an issue): ",
	"richtext unavailable"	=> "There\'s a WYSIWYG html editor (RichText editor) available in IE 5.5+ :-(.",

//	"article to group1"		=> "Insert following articles:",
//	"article to group2"		=> "into this group:",

	"edit elses art"		=> "Note, that you edit else's article, which is not yet finished !!",
	"unable to edit1"		=> "If you check this, you won't be able to edit this article any more.",
	"unable to edit2"		=> "Save the article again, if you really want to do this.",
	"comma separator"		=> "Use comma as separator.",
	"initial group"			=> "Here you can select the initial group for your article.",
	"article signature"		=> "The initial signature is copied from your user preferences.",
	"editor submit"			=> "Are you sure you have finished editing?",
	"pick article"			=> "... pick an article",
	"already approved"		=> "Can't approve (already approved): ",
	"approved"				=> "Approved: ",
	"unapproved"			=> "Unapproved: ",
	"not approved"			=> "Can't unapprove (not approved): ",
	"by"					=> " by ",

	"menu order"			=> "The order of articles is significant",
	"menu title"			=> "This will be displayed in issue menu. \\nUse when the article title is too long.",
	"menu titles"			=> "Use when the article titles are too long. \\nYou can even enter something completely different.",
	"no menu title"			=> "This menu title is empty.",
	"menu groups"			=> "Use to create article grouping in the issue menu.",

// groups

	"pick group"			=> "... pick a group",
	"exported group"		=> "This means, that the group will be visible in online journal group list. \\n",

// article grouping

	"noown grouping"		=> "removed, it's not your article",
	"no art left"			=> "Sorry, no article left to process.",
	"insert into"			=> "insert into",
	"remove from"			=> "remove from",
	"get groups"			=> "list groups",
	"no action selected"	=> "You have to select an action.",
	"article is in group"	=> "You can't insert this article, it's already in that group",
	"article not in group"	=> "You can't remove this article, it's not in that group",
	"articles were in"		=> "article(s) were in this group.",

// issues

	"pick issue"			=> "... pick an issue",
	"more articles"			=> "Increase number of articles in this issue",
	"less articles"			=> "Decrease number of articles in this issue",
	"published issue"		=> "Published issue: ",
	"unpublishing issue"	=> "Unpublishing issue: ",
	"already archived"		=> "Can't archive (already archived): ",
	"noarch is published"	=> "Can't archive (this issue is published): ",
	"archived issue"		=> "Archived issue: ",
	"unarchived issue"		=> "Issue removed from archive: ",
	"already unarchived"	=> "Can't unarchive (already unarchived): ",

// users

	"no username"			=> "You must enter a username",
	"no delete yourself"	=> "You can't delete yourself while logged in",
	"no old"				=> "You must enter your old password here",
	"no pass"				=> "Enter here your new password",
	"no retry"				=> "Re-enter your new password here",
	"no match"				=> "The given passwords don't match, please retry",
	"bad oldpass"			=> "The password you've given as current is wrong, please retry",

// image upload
	"input data empty"		=> "There are no images uploaded.",
	"image code"			=> "You have to cut & paste the text in \'Code\' line to your article !!\\nUse \'code\' button next to image to create the \'Code\' line for the selected image.",

);

function msg ($id, $db_item="") {
	global $MSG;
	if (in_array ($id, array_keys ($MSG))) {
		if (func_num_args () == 2)
			return preg_replace ("/%ITEM%/", $MSG[$db_item], $MSG[$id]);
		else
			return "${MSG[$id]}";
	} else
		// DEBUG: mark this as nonexistent msg request
		return "<SPAN style=\"color:orange\">$id</SPAN>";
}

/* old version : 
function msg ($id) {
	global $MSG;
	if (in_array ($id, array_keys ($MSG)))
		return "${MSG[$id]}";
	else
		// DEBUG: mark this as nonexistent msg request
		return "<SPAN style=\"color:orange\">$id</SPAN>";
}
/**/
?>
