<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# gui templates : globals
#

	// image directory
	$IMG_DIR = $BASE_ADMIN_URL . "/gui/img";

/**	
 *	GUI class to help render the final HTML.<br>
 *	Based on switching between two different rendering modes (special / content).
 *	
 *	@author Jan Hnatek
 */
class gui {
//-------//

	// VARIABLES
	//
	// table border (set to '1' to debug table layout)
	var $tb;
	
	// some html head values
	var $title;
	var $img_dir;
	var $cssfile;
	var $content_description;
	
	// national settings
	// TODO: make separate function to set them up
	//var $charset = "iso-8859-2";
	var $charset = "Windows-1250";
	var $language = "cs";
	
	// some body settings
	var $bg = "white";
	var $text = "330099";
	
	// menu special items array
	var $menu_special;
	// and memory for classes
	var $menu_class;
	var $menu_sepclass;
	
	// special block settings
	var $spbg = "#CCCCEE";


	// CONSTRUCTOR
	//
	function gui ($title, $img_dir, $cssfile="style.css", $content_desc="", $tb="0") {
		$this->title = $title;
		$this->img_dir = $img_dir;
		$this->cssfile = $cssfile;
		$this->content_description = $content_desc;
		$this->tb = $tb;
		$this->menu_special = array (
			"\L"	=> "-&lt;", // -<
			"\R"	=> "&gt;-",
			"\S"	=> "&gt;--&lt;",
			"\SS"	=> " :: ",
		);
	}

		// PRIVATE METHODS
		//
		/**	@access	private
		 */
		function _open_head () { 
		//********************** ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=<?= $this->charset?>">
	<meta http-equiv="Content-language" content=<?= $this->language?>><!---->
	<meta http-equiv="Cache-Control" content="no-cache"> 
	<meta name="generator" content="none">
	<meta name="description" content="<?= $this->content_description ?>">
	<link rel="stylesheet" type="text/css" href="<?= $this->cssfile ?>">
	<title><?= $this->title ?></title>
<?		//**********************
		} // _open_head
		
		/**	@access	private
		 */
		function _document_start () {
		//***************************
			$this->_open_head (); ?>
</head>

<body <?= $this->get_body_attr (); ?>>
<div align="center">
	
<!-- document start -->
<table <?= $this->get_table_attr (); ?>>
<tr valign="top">
	<td align="left">
<?		//***************************
		} // _document_start
		
		/**	@access	private
		 */
		function _document_end () {
		//*************************	?>
	</td>
</tr>
</table>
<!-- document end -->

</div>
</body>
</html>
<?		//*************************
		} // _document_end
		
		/**	@access	private
		 */
		function _special_start () { ?>
	<!-- special start -->
	<table width="100%" align="center" border="1" cellpadding="0" cellspacing="0" bgcolor="<?= $this->spbg?>">
	<tr valign="top">
		<td align="left">
<?		} // _special_start
		function _special_end () { ?>
		</td>
	</tr>
	</table>
	<!-- special end -->	
<?		} // _special_end
		/**	@access	private
		 */
		function _separator () {
			if ($this->special) { ?>
		</td>
	</tr>
	<!-- separator -->
	<tr valign="top">
		<td align="left">
<?			} else { ?>
	</td>
</tr>
<!-- separator -->
<tr><td height="3"></td></tr>
<tr valign="top">
	<td align="left">
<?			// <tr><td bgcolor="<?= $this->bg? >"><?= $this->glue (10,3)? ></td></tr>
			} // if (special)
		} // _separator
		/**	.
		 *	@access	private
		 */
		function _content_start () { ?>
<?		} // _content_start
		
		/**	Finalize current content.
		 *	@access	private
		 */
		function _content_end () { ?>
<?		} // _content_end


	// PUBLIC METHODS
	//
	/** Create a separator in currently active section (special/content)
	 *	@access	public
	 */
	function separator () {
		$this->_separator ();
	}
	/** Insert invisible image of specified width/height.
	 *	@return img tag string
	 *	@access	public
	 */
	function glue ($w, $h) {
		return '<img src="img/voodoo.gif" width="'.$w.'" height="'.$h.'" alt="glue">';
	}
	/**	Create a heading from given string.
	 *	@return void
	 *	@access	public
	 */
	function heading ($msg) {
		// FIXME: h1 nejde nastavit normalni velikost ??? in style.css ???
		//echo "<h1>$msg</h1>";
		echo "<p class=\"h1\">$msg</p>";
	}

	// DOCUMENT : MENU RENDERING
	//

	/**	Menu rendering function.
	 *	In fact, it calls <code>menu_begin</code> and <code>menu_end</code> functions.
	 *	@param	$values		The array of items for the menu table.
	 *	@param	$class		Name of the css class to use with table items.
	 *	@param	$special	Associative array of items with special meaning. The items from $values 
	 *		which are as any key value in $special will be replaced with corresponding value from $special.
	 *	@param	$sepclass	Name of the css class to use with table special items.
	 *	@return void
	 *	@access	public
	 */
	function menu ($values, $class, $special="", $sepclass="") {
		$this->menu_begin ($values, $class, $special, $sepclass);
		$this->menu_end ();
	}
	/**	Menu rendering function - creates another menu boxes from given values.
	 *	@param	$values		The array of items for the menu table.
	 *	@return void
	 *	@access	public
	 */
	function menu_next ($values) {
		foreach ($values as $val) {
			if ( ($this->menu_special != "") && (in_array ($val, array_keys ($this->menu_special))) ) {
				if ($this->menu_sepclass != "")
					$sepclass = " class=".$this->menu_sepclass;
				echo "\t\t<td><span". $sepclass .">" . $this->menu_special[$val] . "</span></td>\n";
			} else {
				if (preg_match ("/<a /i", $val))
					$val = preg_replace ("/<a /i", "<a class=". $this->menu_class ." ", $val);
				echo "\t\t<td><span class=". $this->menu_class .">" . $val . "</span></td>\n";
			}
		}
	}
	/**	Start menu rendering - creates first menu boxes from given values.
	 *	@param	$values		The array of items for the menu table.
	 *	@return void
	 *	@access	public
	 */
	function menu_begin ($values, $class, $special="", $sepclass="") {
		$this->menu_class = $class;
		$this->menu_sepclass = $sepclass;
		if ($special != "")
			$this->menu_special = $special;
		echo "<table class=". $this->menu_class ." summary=\"\"><!-- menu table -->\n";
		echo "\t<tr class=". $this->menu_class .">\n";
		$this->menu_next ($values);
	}
	/**	Finalize menu rendering.
	 *	@return void
	 *	@access	public
	 */
	function menu_end () {
		echo "\t</tr>\n";
		echo "</table><!-- menu table -->\n";
	}

	// DOCUMENT : MAIN PARTS RENDERING
	//

	/** Start rendering of a document.
	 *	@access	public
	 */
	function start ($tb) {
		$this->tb = ($tb != "") ? '1' : '0';
		$this->_document_start ();
	}
	/** Switch to 'special' section of a document.
	 *	@access	public
	 */
	function special ($tb="") {
		$this->tb = ($tb != "") ? '1' : '0';
		if (!$this->special) {
			$this->special = true;
			$this->_content_end ();
		}
		$this->_special_start ();
	}
	/** Switch to 'content' section of a document.
	 *	@access	public
	 */
	function content ($tb="") {
		$this->tb = ($tb != "") ? '1' : '0';
		if ($this->special) {
			$this->special = false;	
			$this->_special_end ();
		}
		$this->_content_start ();
	}
	/** Finalize rendering of the document.
	 *	@access	public
	 */
	function end () {
		if ($this->special)
			$this->_special_end ();
		else
			$this->_content_end ();
		$this->_document_end ();
	}
	/** Return string with default table attributes.
	 *	@access	public
	 */
	function get_table_attr () {
		return 'width="100%" border="'.$this->tb.'" cellpadding="0" cellspacing="0"';
	}
	/** Return string with default body attributes.
	 *	@access	public
	 */
	function get_body_attr () {
		return 'bgcolor="'.$this->bg.'" text="'.$this->text.'" leftmargin="0" topmargin="0" marginright="0" marginwidth="0" marginheight="0" ';
	}
	/** Return image anchor.
	 *	@access	public
	 */
	function get_image ($name, $alt, $attr="") {
		$name = preg_replace ("/^.*[\/]/", "", $name);
		/*global $ADMIN_DIR;
		$filename = $ADMIN_DIR . '/img/' . $name;
		$size = GetImageSize ($filename);
		if ($size)
			$size = $size[3];
		*/
		return "<img src=\"" . $this->img_dir .'/'. $name ."\" $size alt=\"$alt\" $attr>";
	}

} // class gui

?>
