<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# ADMIN PART index.php
# entry point of the ArtSys administration pages
#

	require_once "../config.php";
	require_once "$INCLUDE_DIR/globals.php";
	require_once "$INCLUDE_DIR/db.php";

session_start();

if (isset ($login)) {

	###############################################################################
	# login check
	#

	//debug ("login: $login; pass: $passwd");
	// open db and get user by username
	$db->open ();

    // FIXME: remove unwanted characters from login (PHP escapes ' to \' but ...)
    //$login = preg_replace("/[^_a-zA-Z0-9]/", "", $login);

	// try to find user in db
	$db->exec ("SELECT id, password, name FROM Users WHERE username='$login' AND blocked='0';");
	// noscript notification
	// FIXME: browser detection here ?
	print "<NOSCRIPT>${MSG['noscript']}</NOSCRIPT>";

	// if no results returned
	if ( !($num = $db->num_rows ()) ) {
		//debug ("login: no such user");
		print "<SCRIPT>alert('${MSG['wrong login']}'); document.location.href='index.php';</SCRIPT>\n";
	} else {
		// we got some results, check them
		list ($id, $db_passwd, $name) = $db->get_result ();

		// encrypt password
		if (trim ($passwd) != "") {
			$passwd = md5 ($passwd);
		} else {
			// empty password given .. we don't like this
			//debug ("login: empty passwd");
			print "<SCRIPT>alert('${MSG['wrong login']}'); document.location.href='index.php';</SCRIPT>\n";
		}
		// compare password
		if (strcmp ($db_passwd, $passwd)) {
			// if the password entered does not match the database record, ask user to login again
			//debug ("login: passwords don't match");
			print "<SCRIPT>alert('${MSG['wrong login']}'); document.location.href='index.php';</SCRIPT>\n";
		} else {
			// pasword and username are both OK
			//debug ("login: ok (you are $name with id $id)");

			// set up the admin session then take the user into the admin section of the site
			session_register ("user_name");
			$user_name = $name;
			session_register ("user_id");
			$user_id = $id;
			session_register ("session_id");
			// generate a unique session_id
			$time = time ();
			mt_srand ((double) microtime() * 1000000);
			// this creates a 64bytes long random unique string
			$session_id = md5 (uniqid (mt_rand(), true)) . md5 (uniqid (mt_rand(), true));
			// and place it into database
			$db->exec ("INSERT INTO Sessions (id, userid, username, ip, time)
				VALUES ('$session_id', '$user_id', '$user_name', '$REMOTE_ADDR', '$time');");

			// redirect to main.php
			session_register ("section");
			session_register ("subsection");
			$section = "articles";
			$subsection = "";
			print "<SCRIPT>document.location.href='main.php'</SCRIPT>\n";
		}
	}
} else {

	###############################################################################
	# login screen
	#
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<title><?echo msg('login screen');?></title>
	<style>
	body {
		font-family: Lucida, Verdana, Helvetica CE, Arial CE, Arial, Helvetica, sans-serif;
		font-weight: bold;
		font-size: 12 pt;
		color: #6655BB;
	}
	p {
		font-family: Lucida, Verdana, Helvetica CE, Arial CE, Arial, Helvetica, sans-serif;
		font-weight: bold;
		font-size: 12 pt;
		color: #6655BB;
	}
	td.img {
		background-color: white;
	}
	</style>
</head>
<body text="#6655BB" bgcolor="#CCCCCC">
<table align="center" border="0" cellpadding="0" cellspacing="0" width="350">
	<form method="post" action="index.php">
	<tr><td colspan="4" height="50"></td></tr>
	<tr bgcolor="white">
		<td align="left" bgcolor="white" colspan="4">
			<div align="left"><img src="<?= $BASE_ADMIN_URL. '/gui/img/login1.gif'?>"
			alt="article system" align="left" width="218" height="30" border="0"></div></td>
		</tr>
	<tr><td height="3" bgcolor="#6655BB" colspan="4"></td></tr>
	<tr><td width="10" bgcolor="#6655BB"></td>
		<td height="5" colspan="3"></td></tr>

	<tr><td width="10" bgcolor="#6655BB"></td>
		<td width="100" align="right"><p><?echo msg('login username');?></td>
		<td align="right"><input type="text" name="login" size="25" value="">&nbsp;</td>
		<td></td></tr>
	<tr><td width="10" bgcolor="#6655BB"></td>
		<td width="100" align="right"><p><?echo msg('login passwd');?></td>
		<td align="right"><input type="password" name="passwd" size="25" value="">&nbsp;</td>
		<td width="10"></td></tr>
	<tr><td height="5" colspan="3"></td>
		<td width="10" bgcolor="#6655BB"></td></tr>
	<tr><td></td>
		<td colspan="2" align="right">
			<input type="submit" value="<?echo msg('login submit');?>">&nbsp;
			<input type="reset" value="<?echo msg('login reset');?>">&nbsp;&nbsp;&nbsp;
		</td>
		<td width="10" bgcolor="#6655BB"></td></tr>

	<tr><td height="5" colspan="3"></td>
		<td width="10" bgcolor="#6655BB"></td></tr>
	<tr><td height="3" bgcolor="#6655BB" colspan="4"></td></tr>
	<tr bgcolor="white">
		<td align="right" bgcolor="white" colspan="4">
			<div align="right"><img src="<?= $BASE_ADMIN_URL. '/gui/img/login2.gif'?>" 
			alt="login screen" align="right" width="186" height="29" border="0"></div></td>
		</tr>
	<tr><td>&nbsp;</td></tr>
	</form>
</table>
</body>
</html>
<?
}
?>

