<?php

/*
 *	Article System
 *	Online journal management tool
 written in PHP/MySQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2002 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  07/05/2002
 *	Version:  0.1-1 (pre-alpha)      	
 */

###############################################################################
# ADMIN PART main.php
# main screen of the administrations pages
#

	// some includes :-)
	require_once "../config.php";

// *** send page encoding header information
	// since the default may be forced to iso-8859-1, which we may not want
	header ("Content-type: text/html; charset=$CHARSET");

	require_once "$INCLUDE_DIR/globals.php";
	require_once "$INCLUDE_DIR/db.php";
	require_once "$INCLUDE_DIR/classes.php";
	require_once "./include.php";
	require_once "gui/class.gui.php";

	require_once "$INCLUDE_DIR/classes/class.main.php";
	require_once "$INCLUDE_DIR/classes/class.modules.php";

	require_once "$INCLUDE_DIR/classes/class.user.php";


// *** session check begin

	// Note: this block appears in {main.php, images.php, art_view.php}
	// and should be the same in all of them
	// clear old sessions from DB
	$old = time () - $SESSION_LIFETIME;
	$db->open ();
	$db->exec ("DELETE FROM Sessions WHERE time < $old");

	// get session_id and compare it with database
	session_start();
	session_register ("session_id");
	if ($session_id) {
		// some session is opened
		$db->exec ("SELECT * FROM Sessions WHERE id='$session_id';");
		// if such session is not in DB
		if ($db->num_rows () != 1) {
			header("Location: index.php");
			exit;
		}
	} else {
		// no session is opened
		header("Location: index.php");
		exit;
	}
	// there is something in the sessions after all ... so check user_ip
	$session_data = $db->get_result_array ();
	if ($session_data && $session_data['ip'])
		if ($REMOTE_ADDR != $session_data['ip']) {
	  		header("Location: index.php");
	  		exit;
		}
	// update session time
	$time = time();
	$db->exec ("UPDATE Sessions SET time='$time' WHERE id='$session_id';");

// *** session check end

// set/get session variables
session_register ("section");
//debug ("sec: $sec");
if ($sec)		$section = $sec;
if (!$section)	$section = "articles";		// default target when not set

session_register ("subsection");
//debug ("sub: $sub");
if ($sub)			$subsection = $sub;
if (!$subsection)	$subsection = "";		// tell the module to display it's default

// handle logout
if (($sec == "logout") || ($sub == "logout")) {
	// remove session information from DB
	$db->exec ("DELETE FROM Sessions WHERE id='$session_id';");
	// destroy session vars
	session_destroy ();
	// run away
	print "<SCRIPT>document.location.href='index.php'</SCRIPT>\n";
	exit;
}

// create user object (for rights)
$user =& new user ($user_id);

	###############################################################################
	# final html
	#

	// register modules
	$parts = $user->get_parts ();
	// create new main object
	$main =& new main ($PROJECT_NAME, $parts);
	// get current title (based on section/subsection)
	$title = $main->get_title ();
	
	// start gui
	$gui =& new gui ($title, $IMG_DIR, "gui/style.css", $PROJECT_NAME);
	$gui->start ($tb = false);
	echo "\t<div align=\"center\">" . $gui->get_image ("headlogo.gif", "article system logo", 'align="center"') . "</div>\n";
	$gui->special ($tb = false);
	
	// display main menu ...
	$main->display ();
	$active_module = $main->get_active ();
	if (!$active_module)
		exit;
	// ... and module menu
	$active_module->display ();
	
	// tell gui, that we have finished rendering menu
	$gui->content ($tb = true);
	
	// get include filename
	$include_file = $active_module->get_include ();
	
	//echo "\n\n<hr>\n\n";
	$gui->separator ();
	
	// deploy scripts
	$main->insert_script ();
	help_script (); ?>

<!-- sub - content begin -->

<?	// include (section, subsection) corresponding file
	require_once "$include_file";
	
	// finish off gui :-)
	$gui->end ();
?>
